# -*- coding: utf-8 -*-
"""
Created on Sat Dec 14 10:45:20 2018

@author: sagar


"""

import io
import os
import sys
import glob
import json
import time
import uuid
import shutil
import datetime


def make_timestamp():
    return datetime.datetime.now(datetime.timezone.utc).astimezone().replace(microsecond=0).isoformat()


def create_uuid():
    return str(uuid.uuid4())


def file_check(file):
    file_exists = 0
    if os.path.isfile(file) == True:
        file_exists = 1
    return file_exists


def dir_check(path):
    dir_exists = 0
    if os.path.isdir(path) == True:
        dir_exists = 1
    return dir_exists


def write_json(json_output_file, output_dict):
    try:
        with open(json_output_file, 'w+') as json_file:
            json.dump(output_dict, json_file, sort_keys=False, ensure_ascii=False)
        return 1
    except:
        return 0, 'unable to write file - ' + json_output_file

def write_formatted_json(json_output_file, output_dict):
    try:
        with open(json_output_file, 'w+') as json_file:
            json.dump(output_dict, json_file, indent=2, sort_keys=False, ensure_ascii=False)
            return 1
    except:
        return 0, 'unable to write file - ' + json_output_file


def read_json(file):
    try:
        with open(file) as json_file:
            return json.load(json_file)
    except:
        return 0, 'unable to read file - ' + file

def print_formatted_json(json_dict):
    try:
        print(json.dumps(json_dict, indent=2))
    except:
        return 0, 'unable to print dict'

def print_json(json_dict):
    try:
        print(json.dumps(json_dict))
    except:
        return 0, 'unable to print dict'


#move_file(source_file, dir, new_filename(optional))
def move_file(*args):
    from_location = args[0]
    new_dir = args[1]
    if file_check(from_location) != 1:
        raise FileNotFoundError(from_location)
    elif dir_check(new_dir) != 1:
        raise FileNotFoundError(new_dir)
    else:
        if len(args) == 2:
            shutil.copy2(from_location, new_dir)
        elif len(args) > 2:
            new_file = os.path.join(new_dir, args[2])
            if new_file in os.listdir(new_dir):
                return 0, 'the source file already exists in the destination dir'
            shutil.copy2(from_location, new_file)
        else:
            return 0, 'move_file(); missing arguments'
